#!/usr/bin/perl

use KCatch;

#カウンタCGI「SQLカウンタ」 by みけCAT

use DBI;

#設定ここから
$password="1234";				#管理用パスワード
$auto_logout=20;				#何分で自動ログアウトするか

$use_imk=0;						#ImageMagickを使うか
$comment_max=1024;				#キリ番取得時のコメントの最大の長さ

$return_url="../index.html";	#戻り先のURL
$normalimage="normal";			#通常の画像のフォルダ
$kiriimage="kiriban";			#キリ番時の画像のフォルダ

#データベースの設定
$database="sqlcount";			#データベースの名前
$user="test";					#データベースのユーザー名
$pass="test";					#データベースのパスワード
$host="localhost";				#データベースのホスト
$port="3306";					#データベースのポート
#設定ここまで

if($use_imk) {
	require Image::Magick;
}

# 日本時刻のための環境変数
$ENV{'TZ'} = "JST-9";

#初期設定、変えるときは管理画面から設定してください
%CONFIG=();
$CONFIG{'keta'}=5;				#桁数
$CONFIG{'dayketa'}=4;			#一日統計の桁数
$CONFIG{'overmode'}=0;			#あふれたらどうするか
# $overmodeが0　　　　 : あふれていない下の方の桁のみ表示
# $overmodeが1　　　　 : あふれたらすべての数字に9を表示
# $overmodeが2　　　　 : あふれたらエラーを表示
# $overmodeが3、その他 : 必要な桁数を強制的に表示
$CONFIG{'nodtime'}=3600;		#二重カウントしない時間
$CONFIG{'show_kiri'}=0;			#キリ番を表示する場合は1
$CONFIG{'do_kirilog'}=0;		#キリ番のログをとる場合は1
#ここからキリ番の条件（すべて0で無効）
$CONFIG{'kiri_10bai'}=2;		#10^nの倍数
$CONFIG{'kiri_mirror'}=4;		#ミラー番
$CONFIG{'kiri_leftlen'}=4;		#1234のような左からの連番# 4321など右からの連番
$CONFIG{'kiri_rightlen'}=4;		#4321のような右からの連番
$CONFIG{'kiri_zorome'}=-3;		#下n桁がゾロ目（-nはn桁以上の全体がゾロ目）


#読み込み
if ($ENV{'REQUEST_METHOD'} eq "POST") {
	# POSTであれば標準入力から読込みます
	read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
} else {
	# GETであれば環境変数から読込みます
	$query_string = $ENV{'QUERY_STRING'};
}

# 「変数名1=値1&変数名2=値2」の形式をアンパサンド( & )で分解します
@a = split(/&/, $query_string);
# それぞれの「変数名=値」について
foreach $a (@a) {
	# イコール( = )で分解します
	($name, $value) = split(/=/, $a);
	# + や %8A などをデコードします
	$value =~ tr/+/ /;
	$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
	# 後で使用する場合は、$FORM{'変数名'} に代入しておきます
	$FORM{$name} = $value;
}

#データベースに接続
$dsn = "DBI:mysql:$database:$host:$port";
%attr = (RaiseError=>0, PrintError=>1,AutoCommit=>1);
unless($dbh = DBI->connect($dsn,$user,$pass,\%attr)) {
	if($FORM{'mode'} eq "total") {
		print "Content-type: image/gif\n";
		print "\n";
		@files = ();
		for ($i = 0; $i < $CONFIG{'keta'}; $i++) {
			push(@files, "$normalimage/err.gif");
		}
		require "gifcat.pl";
		binmode(STDOUT);
		print &gifcat'gifcat(@files);
	} elsif($FORM{'mode'} eq "today" || $FORM{'mode'} eq "yesterday") {
		print "Content-type: image/gif\n";
		print "\n";
		@files = ();
		for ($i = 0; $i < $CONFIG{'dayketa'}; $i++) {
			push(@files, "$normalimage/err.gif");
		}
		require "gifcat.pl";
		binmode(STDOUT);
		print &gifcat'gifcat(@files);
	} else {
		print "Content-type: text/html\n";
		print "\n";
		print "<html>\n<head>\n";
		print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
		print "<title>SQLカウンタ</title>\n";
		print "</head>\n<body>\n";
		print "<h2>SQLカウンタ&nbsp;-&nbsp;エラー</h2>\n";
		print "<p>データベース接続時にエラーが発生しました。</p>\n";
		print "<p>$DBI::errstr</p>\n";
		print "<HR>\n";
		print "<p><a href=\"$return_url\">戻る</a></p>\n";
		print "</body>\n</html>";
	}
	exit(0);
}

#テーブルの作成
$sql="create table if not exists sqlcount_counttable(" .
	"name text not null,value int not null);";
$dbh->do($sql);
$sql="create table if not exists sqlcount_configtable(" .
	"name text not null,value int not null);";
$dbh->do($sql);
$sql="create table if not exists sqlcount_nodtable(" .
	"ipaddr text not null,count int not null,zikan int not null);";
$dbh->do($sql);
$sql="create table if not exists sqlcount_kirilog(" .
	"id serial,ipaddr text not null,reported int not null," .
	"count int not null,zikan int not null,name text,comment text);";
$dbh->do($sql);
$sql="create table if not exists sqlcount_adminlogin(" .
	"id text not null,ipaddr text not null,zikan int not null);";
$dbh->do($sql);

#設定の読み出し
$sql="select name,value from sqlcount_configtable;";
if($sth = $dbh->prepare($sql)) {
	if($rv = $sth->execute) {
		while(@row = $sth->fetchrow_array) {
			$CONFIG{$row[0]}=$row[1];
		}
		$sth->finish;
	}
}

$sql="lock table sqlcount_nodtable write,sqlcount_counttable write;";
$dbh->do($sql);
#カウント値を取得
%COUNT=();
$COUNT{'total'}=0;
$COUNT{'today'}=0;
$COUNT{'yesterday'}=0;
$COUNT{'today_date'}=&gettoday();
$sql="select name,value from sqlcount_counttable;";
if($sth = $dbh->prepare($sql)) {
	if($rv = $sth->execute) {
		while(@row = $sth->fetchrow_array) {
			$COUNT{$row[0]}=$row[1];
		}
		$sth->finish;
	}
}

#カウントアップ
$doublecount=0;
if($FORM{'mode'} eq "total" || $FORM{'mode'} eq "today" || $FORM{'mode'} eq "yesterday") {
	#一定時間が経過した二重カウント防止情報を削除
	$deltime=time()-$CONFIG{'nodtime'};
	$sql="delete from sqlcount_nodtable where zikan<$deltime;";
	$dbh->do($sql);
	#二重カウント防止情報があるかどうかを見る
	$sql="select count from sqlcount_nodtable where ipaddr=" . $dbh->quote($ENV{'REMOTE_ADDR'}) . ";";
	if($sth = $dbh->prepare($sql)) {
		if($rv = $sth->execute) {
			if(@row = $sth->fetchrow_array) {
				$doublecount=1;
				$COUNT{'total'}=$row[0];
			}
			$sth->finish;
		}
	}
	#カウントアップ
	#昨日と今日のカウント値の切り替え
	$today_date=&gettoday();
	$yesterday_date=&getyesterday($today_date);
	if($COUNT{'today_date'}!=$today_date) {
		if($COUNT{'today_date'}==$yesterday_date) {
			$COUNT{'yesterday'}=$COUNT{'today'};
		} else {
			$COUNT{'yesterday'}=0;
		}
		$COUNT{'today'}=0;
	}
	$COUNT{'today_date'}=$today_date;
	if(!$doublecount) {
		#カウントアップ
		$COUNT{'total'}++;
		$COUNT{'today'}++;
		#データベースに書き込み
		$sql="delete from sqlcount_counttable;";
		$dbh->do($sql);
		foreach $key ( keys( %COUNT ) ) {
			$sql="insert into sqlcount_counttable (name,value) values (".$dbh->quote($key).",".$COUNT{$key}.");";
			$dbh->do($sql);
		}
	}
	#二重カウント防止情報に書き込み
	if($doublecount) {
		$sql="update sqlcount_nodtable set zikan=".time()." where ipaddr=".$dbh->quote($ENV{'REMOTE_ADDR'}).";";
	} else {
		$sql="insert into sqlcount_nodtable (ipaddr,zikan,count) values (".$dbh->quote($ENV{'REMOTE_ADDR'}).",".time().",".$COUNT{'total'}.");";
	}
	$dbh->do($sql);
}
$sql="unlock table;";
$dbh->do($sql);

#一定時間が経過したログインデータの削除
$deltime=time()-$auto_logout*60;
$sql="delete from sqlcount_adminlogin where zikan<" . $deltime . ";";
$dbh->do($sql);

#モードに応じたデータの書き出し
if($FORM{'mode'} eq "total") {
	#キリ番の判定
	$kiribanok=0;
	$countstr="" . $COUNT{'total'};
	if($CONFIG{'kiri_10bai'}>0) { # 10^nの倍数
		$target=1;
		for($i=0;$i<$CONFIG{'kiri_10bai'};$i++){$target*=10;}
		if($COUNT{'total'} % $target ==0) {
			$kiribanok=1;
		}
	}
	if($CONFIG{'kiri_mirror'}>0) { # 左右対称の数字
		$len=length($countstr);
		$ok=1;
		if($len<$CONFIG{'kiri_mirror'}){$ok=0;}
		for($i=0;$i<$len;$i++) {
			if(substr($countstr,$i,1) ne substr($countstr,$len-$i-1,1)) {
				$ok=0;
				last;
			}
		}
		if($ok==1) {
			$kiribanok=1;
		}
	}
	if($CONFIG{'kiri_leftlen'}>0) { # 1234など左からの連番
		$len=length($countstr);
		$ok=1;
		if($len<$CONFIG{'kiri_leftlen'}){$ok=0;}
		$num=int(substr($countstr,0,1));
		for($i=1;$i<$len;$i++) {
			$num++;
			if($num>10) {
				$ok=0;
				last;
			}
			if(substr($countstr,$i,1) ne ("" . ($num%10))) {
				$ok=0;
				last;
			}
		}
		if($ok==1) {
			$kiribanok=1;
		}
	}
	if($CONFIG{'kiri_rightlen'}>0) { # 4321など右からの連番
		$len=length($countstr);
		$ok=1;
		if($len<$CONFIG{'kiri_rightlen'}){$ok=0;}
		$num=int(substr($countstr,0,1));
		for($i=1;$i<$len;$i++) {
			$num--;
			if($num<0) {
				$ok=0;
				last;
			}
			if(substr($countstr,$i,1) ne "$num") {
				$ok=0;
				last;
			}
		}
		if($ok==1) {
			$kiribanok=1;
		}
	}
	if($CONFIG{'kiri_zorome'}!=0) { #ゾロ目
		$len=length($countstr);
		$needlen=$CONFIG{'kiri_zorome'};
		if($needlen<0){$needlen=$len;}
		$suuzi=substr($countstr,$len-1,1);
		$ok=1;
		if($CONFIG{'kiri_zorome'}<0 && $len<(-$CONFIG{'kiri_zorome'})){$ok=0;}
		for($i=$len-$needlen;$i<$len;$i++) {
			if(substr($countstr,$i,1) ne $suuzi) {
				$ok=0;
				last;
			}
		}
		if($ok==1) {
			$kiribanok=1;
		}
	}
	if($kiribanok && !$doublecount && $CONFIG{'do_kirilog'}) {
		#キリ番ログに書き込み
		$sql="insert into sqlcount_kirilog (ipaddr,reported,count,zikan) value (".
			$dbh->quote($ENV{'REMOTE_ADDR'}).",0,".$COUNT{'total'}.",".time().");";
		$dbh->do($sql);
	}
	#桁あふれの判定
	$error=0;
	if(length($countstr)<=$CONFIG{'keta'}) {
		while(length($countstr)<$CONFIG{'keta'}) {
			$countstr="0" . "$countstr";
		}
	} else {
		if($CONFIG{'overmode'}==0) { # あふれていない下の桁だけ表示
			$countstr=substr($countstr,length($countstr)-$CONFIG{'keta'},$CONFIG{'keta'});
		} elsif($CONFIG{'overmode'}==1) { # すべての数字に9を表示
			$countstr="";
			for($i=0;$i<$CONFIG{'keta'};$i++) {
				$countstr="$countstr" . "9";
			}
		} elsif($CONFIG{'overmode'}==2) {
			$error=1;
		}
	}
	#カウンタ画像の書き出し
	print "Content-type: image/gif\n";
	print "\n";
	@files = ();
	if($error==0) {
		if($kiribanok==1 && $CONFIG{'show_kiri'}) {
			$image=$kiriimage;
		} else {
			$image=$normalimage;
		}
		for ($i = 0; $i < length($countstr); $i++) {
			$n = substr($countstr, $i, 1);
			push(@files, "$image/$n.gif");
		}
	} else {
		for ($i = 0; $i < $CONFIG{'keta'}; $i++) {
			push(@files, "$normalimage/err.gif");
		}
	}
	binmode(STDOUT);
	if($use_imk) {
		$img = Image::Magick -> new;
		for($i=0;$i<0+@files;$i++) {
			$img -> Read($files[$i]);
		}
		$img = $img -> Append(stack => 'false');
		$img -> Write('gif:-');
	} else {
		require "gifcat.pl";
		print &gifcat'gifcat(@files);
	}
} elsif($FORM{'mode'} eq "today" || $FORM{'mode'} eq "yesterday") {
	if($FORM{'mode'} eq "today") {
		$countstr="" . $COUNT{'today'};
	} else {
		$countstr="" . $COUNT{'yesterday'};
	}
	#桁あふれの判定
	$error=0;
	if(length($countstr)<=$CONFIG{'dayketa'}) {
		while(length($countstr)<$CONFIG{'dayketa'}) {
			$countstr="0" . "$countstr";
		}
	} else {
		if($CONFIG{'overmode'}==0) { # あふれていない下の桁だけ表示
			$countstr=substr($countstr,length($countstr)-$CONFIG{'dayketa'},$CONFIG{'dayketa'});
		} elsif($CONFIG{'overmode'}==1) { # すべての数字に9を表示
			$countstr="";
			for($i=0;$i<$CONFIG{'dayketa'};$i++) {
				$countstr="$countstr" . "9";
			}
		} elsif($CONFIG{'overmode'}==2) {
			$error=1;
		}
	}
	#カウンタ画像の書き出し
	print "Content-type: image/gif\n";
	print "\n";
	@files = ();
	if($error==0) {
		for ($i = 0; $i < length($countstr); $i++) {
			$n = substr($countstr, $i, 1);
			push(@files, "$normalimage/$n.gif");
		}
	} else {
		for ($i = 0; $i < $CONFIG{'dayketa'}; $i++) {
			push(@files, "$normalimage/err.gif");
		}
	}
	binmode(STDOUT);
	if($use_imk) {
		$img = Image::Magick -> new;
		for($i=0;$i<0+@files;$i++) {
			$img -> Read($files[$i]);
		}
		$img = $img -> Append(stack => 'false');
		$img -> Write('gif:-');
	} else {
		require "gifcat.pl";
		print &gifcat'gifcat(@files);
	}
} elsif($FORM{'mode'} eq "admin") {
	if($FORM{'action'} eq "login") {
		if($FORM{'pass'} eq $password) {
			#ログイン成功
			#認証コードの作成
			srand;
			@mozi=("0" .. "9" , "A" .. "Z" , "a" .. "z");
			$code="";
			for($i=0;$i<32;$i++) {
				$code .= $mozi[int(rand(62))];
			}
			#同じIPアドレスの前のログインの削除
			$sql="delete from sqlcount_adminlogin where ipaddr=".$dbh->quote($ENV{'REMOTE_ADDR'}).";";
			$dbh->do($sql);
			#認証コードのデータベースへの書き込み
			$sql="insert into sqlcount_adminlogin (id,ipaddr,zikan) values(".
				$dbh->quote($code).",".$dbh->quote($ENV{'REMOTE_ADDR'}).",".time().");";
			$dbh->do($sql);
			#クッキーの設定
			print &setCookie("id",$code);
			print "Content-type: text/html\n\n";
			print "<html lang=\"ja-jp\">\n<head>\n";
			print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
			print "<title>SQLカウンタ　管理画面</title>\n";
			print "<meta http-equiv=\"Refresh\" content=\"1;$ENV{'SCRIPT_NAME'}?mode=admin\">\n";
			print "</head>\n<body>\n";
			print "<h2>SQLカウンタ　管理画面</h2>\n";
			print "<p>ログインに成功しました。</p>\n";
			print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin\">管理画面へ</a></p>\n";
			print "</body>\n</html>";
		} else {
			#ログイン失敗
			print "Location: $ENV{'SCRIPT_NAME'}?mode=admin\n\n";
		}
	} else {
		#認証
		%COOKIE=();
		&getCookie();
		$sql="select id from sqlcount_adminlogin where id=".$dbh->quote($COOKIE{'id'}).
			" and ipaddr=".$dbh->quote($ENV{'REMOTE_ADDR'}).";";
		$loginok=0;
		if($sth = $dbh->prepare($sql)) {
			if($rv = $sth->execute) {
				if(@row = $sth->fetchrow_array) {
					$loginok=1;
				}
				$sth->finish;
			}
		}
		unless($loginok) {
			#認証失敗
			print &clearCookie("id");
			print "Content-type: text/html\n\n";
			print "<html lang=\"ja-jp\">\n<head>\n";
			print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
			print "<title>SQLカウンタ　管理画面</title>\n";
			print "</head>\n<body>\n";
			print "<h2>SQLカウンタ　管理画面</h2>\n";
			print "<h3>ログイン</h3>\n";
			print "<form actipn=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
			print "<p>\n";
			print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
			print "<input type=\"hidden\" name=\"action\" value=\"login\">\n";
			print "パスワード：\n";
			print "<input type=\"password\" name=\"pass\" value=\"\" size=\"16\"><br>\n";
			print "<input type=\"submit\" value=\"ログイン\">\n";
			print "</p>\n</form>\n";
			print "<hr>\n";
			if($CONFIG{'do_kirilog'}) {
				print "<p><a href=\"$ENV{'SCRIPT_NAME'}\">戻る</a></p>\n";
			} else {
				print "<p><a href=\"$return_url\">戻る</a></p>\n";
			}
			print "</body>\n</html>";
		} else {
			#時間の更新
			$sql="update sqlcount_adminlogin set zikan=".time()." where id=".$dbh->quote($COOKIE{'id'}).
				" and ipaddr=".$dbh->quote($ENV{'REMOTE_ADDR'}).";";
			$dbh->do($sql);
			if($FORM{'action'} eq "setcount") {
				#カウント値の変更
				$ok=1;
				if($FORM{'total'} !~ /^[1-9][0-9]*$/){$ok=0;}
				if($FORM{'today'} !~ /^[1-9][0-9]*$/){$ok=0;}
				if($FORM{'yesterday'} !~ /^[1-9][0-9]*$/){$ok=0;}
				if($ok) {
					#データの設定
					$COUNT{'total'}=int($FORM{'total'});
					$COUNT{'today'}=int($FORM{'today'});
					$COUNT{'yesterday'}=int($FORM{'yesterday'});
					#データベースに書き込み
					$sql="lock table sqlcount_counttable write;";
					$dbh->do($sql);
					$sql="delete from sqlcount_counttable;";
					$dbh->do($sql);
					foreach $key ( keys( %COUNT ) ) {
						$sql="insert into sqlcount_counttable (name,value) values (".$dbh->quote($key).",".$COUNT{$key}.");";
						$dbh->do($sql);
					}
					$sql="unlock table;";
					$dbh->do($sql);
					#成功
					print "Content-type: text/html\n\n";
					print "<html lang=\"ja-jp\">\n<head>\n";
					print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
					print "<title>SQLカウンタ　管理画面</title>\n";
					print "</head>\n<body>\n";
					print "<h2>SQLカウンタ　管理画面</h2>\n";
					print "<h3>カウント値の変更</h3>\n";
					print "<p>カウント値を書き換えました。</p>\n";
					print "<hr>\n";
					print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin\">戻る</a></p>\n";
					print "</body>\n</html>";
				} else {
					print "Content-type: text/html\n\n";
					print "<html lang=\"ja-jp\">\n<head>\n";
					print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
					print "<title>SQLカウンタ　管理画面</title>\n";
					print "</head>\n<body>\n";
					print "<h2>SQLカウンタ　管理画面</h2>\n";
					print "<h3>カウント値の変更</h3>\n";
					print "<p>エラー：不正な値があります。</p>\n";
					print "<hr>\n";
					print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin\">戻る</a></p>\n";
					print "</body>\n</html>";
				}
			} elsif($FORM{'action'} eq "setconfig") {
				#設定の変更
				$ok=1;
				if($FORM{'keta'} !~ /^[1-9][0-9]*$/){$ok=0;}
				if($FORM{'dayketa'} !~ /^[1-9][0-9]*$/){$ok=0;}
				if($FORM{'overmode'} !~ /^[0-9]+$/){$ok=0;}
				if($FORM{'nodtime'} !~ /^[0-9]+$/){$ok=0;}
				if($FORM{'kiri_10bai'} !~ /^[0-9]+$/){$ok=0;}
				if($FORM{'kiri_mirror'} !~ /^[0-9]+$/){$ok=0;}
				if($FORM{'kiri_leftlen'} !~ /^[0-9]+$/){$ok=0;}
				if($FORM{'kiri_rightlen'} !~ /^[0-9]+$/){$ok=0;}
				if($FORM{'kiri_zorome'} !~ /^\-?[0-9]+$/){$ok=0;}
				if($ok) {
					#データの設定
					$CONFIG{'keta'}=int($FORM{'keta'});
					$CONFIG{'dayketa'}=int($FORM{'dayketa'});
					$CONFIG{'overmode'}=int($FORM{'overmode'});
					$CONFIG{'nodtime'}=int($FORM{'nodtime'});
					$CONFIG{'show_kiri'}=($FORM{'show_kiri'}?1:0);
					$CONFIG{'do_kirilog'}=($FORM{'do_sqlcount_kirilog'}?1:0);
					$CONFIG{'kiri_10bai'}=int($FORM{'kiri_10bai'});
					$CONFIG{'kiri_mirror'}=int($FORM{'kiri_mirror'});
					$CONFIG{'kiri_leftlen'}=int($FORM{'kiri_leftlen'});
					$CONFIG{'kiri_rightlen'}=int($FORM{'kiri_rightlen'});
					$CONFIG{'kiri_zorome'}=int($FORM{'kiri_zorome'});
					#データベースに書き込み
					$sql="lock table sqlcount_configtable write;";
					$dbh->do($sql);
					$sql="delete from sqlcount_configtable;";
					$dbh->do($sql);
					foreach $key ( keys( %CONFIG ) ) {
						$sql="insert into sqlcount_configtable (name,value) values (".$dbh->quote($key).",".$CONFIG{$key}.");";
						$dbh->do($sql);
					}
					$sql="unlock table;";
					$dbh->do($sql);
					#成功
					print "Content-type: text/html\n\n";
					print "<html lang=\"ja-jp\">\n<head>\n";
					print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
					print "<title>SQLカウンタ　管理画面</title>\n";
					print "</head>\n<body>\n";
					print "<h2>SQLカウンタ　管理画面</h2>\n";
					print "<h3>設定の変更</h3>\n";
					print "<p>設定を書き換えました。</p>\n";
					print "<hr>\n";
					print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin\">戻る</a></p>\n";
					print "</body>\n</html>";
				} else {
					print "Content-type: text/html\n\n";
					print "<html lang=\"ja-jp\">\n<head>\n";
					print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
					print "<title>SQLカウンタ　管理画面</title>\n";
					print "</head>\n<body>\n";
					print "<h2>SQLカウンタ　管理画面</h2>\n";
					print "<h3>設定の変更</h3>\n";
					print "<p>エラー：不正な値があります。</p>\n";
					print "<hr>\n";
					print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin\">戻る</a></p>\n";
					print "</body>\n</html>";
				}
			} elsif($FORM{'action'} eq "kirilist") {
				#キリ番ログ一覧の表示
				print "Content-type: text/html\n\n";
				print "<html lang=\"ja-jp\">\n<head>\n";
				print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
				print "<title>SQLカウンタ　管理画面</title>\n";
				print "</head>\n<body>\n";
				print "<h2>SQLカウンタ　管理画面</h2>\n";
				print "<h3>キリ番ログ一覧</h3>\n";
				print "<p>削除も編集から出来ます。</p>\n";
				print "<table border=\"3\">\n";
				print "<tr><th>編集</th><th>キリ番</th><th>取得された時刻</th>\n";
				print "<th>取得した人の名前</th><th>取得した人のコメント</th></tr>\n";
				#キリ番一覧を読みだし
				@wdays = ( "日", "月", "火", "水", "木", "金", "土", "日" );
				$sql="select reported,count,zikan,name,comment,id from sqlcount_kirilog order by zikan desc;";
				if($sth = $dbh->prepare($sql)) {
					if($rv = $sth->execute) {
						while(@row = $sth->fetchrow_array) {
							($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($row[2]);
							$zikoku=sprintf("%d年%d月%d日(%s)　%d時%d分%d秒",
								$year+1900,$mon+1,$mday,$wdays[$wday],$hour,$min,$sec);
							if($row[0]) {
								#報告済み
								print "<tr><td><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin&action=kiriedit&id=$row[5]\">編集</a></td>\n";
								print "<td>$row[1]</td><td>$zikoku</td>";
								print "<td>$row[3]</td><td>$row[4]</td></tr>\n";
							} else {
								#未報告
								print "<tr><td><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin&action=kiriedit&id=$row[5]\">編集</a></td>\n";
								print "<td>$row[1]</td><td>$zikoku</td>";
								print "<td>(未報告)</td><td>(未報告)</td></tr>\n";
							}
						}
						$sth->finish;
					}
				}
				print "</table>\n";
				print "<hr>\n";
				print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin\">戻る</a></p>\n";
				print "</body>\n</html>";
				
			} elsif($FORM{'action'} eq "kiriedit") {
				#キリ番ログの編集
				print "Content-type: text/html\n\n";
				print "<html lang=\"ja-jp\">\n<head>\n";
				print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
				print "<title>SQLカウンタ　管理画面</title>\n";
				print "</head>\n<body>\n";
				print "<h2>SQLカウンタ　管理画面</h2>\n";
				print "<h3>キリ番ログ編集</h3>\n";
				if($FORM{'id'} !~ /^[0-9]+$/) {
					print "<p>エラー：IDが不正です。</p>\n";
				} else {
					$readok=0;
					$sql="select reported,count,zikan,name,comment from sqlcount_kirilog where id=$FORM{'id'};";
					if($sth = $dbh->prepare($sql)) {
						if($rv = $sth->execute) {
							if(@row = $sth->fetchrow_array) {
								$readok=1;
								$reported=$row[0];
								$count=$row[1];
								@wdays = ( "日", "月", "火", "水", "木", "金", "土", "日" );
								($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($row[2]);
								$zikoku=sprintf("%d年%d月%d日(%s)　%d時%d分%d秒",
									$year+1900,$mon+1,$mday,$wdays[$wday],$hour,$min,$sec);
								$name=$row[3];
								$comment=$row[4];
								$comment =~ s/<br>//g;
							}
						}
					}
					unless($readok) {
						print "<p>エラー：指定されたIDは存在しません。</p>\n";
					} else {
						print "<form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
						print "<table border=\"3\">\n";
						print "<tr><td>取ったキリ番</td>\n";
						print "<td>$count</td></tr>\n";
						print "<tr><td>取得時刻</td>\n";
						print "<td>$zikoku</td></tr>\n";
						print "<tr><td>名前</td>\n";
						print "<td><input type=\"text\" name=\"name\" value=\"$name\" size=\"30\"></td></tr>\n";
						print "<tr><td>コメント</td>\n";
						print "<td><textarea name=\"comment\" rows=\"5\" cols=\"50\">$comment</textarea></td></tr>\n";
						print "<tr><td>状態</td>\n";
						print "<td><select name=\"status\">\n";
						print "<option value=\"notreported\"".($reported?"":" selected").">未報告\n";
						print "<option value=\"reported\"".($reported?" selected":"").">報告済み\n";
						print "<option value=\"delete\">削除\n";
						print "</select></td></tr>\n";
						print "</table>\n";
						print "<p>\n";
						print "<input type=\"hidden\" name=\"id\" value=\"$FORM{'id'}\">\n";
						print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
						print "<input type=\"hidden\" name=\"action\" value=\"kirisend\">\n";
						print "<input type=\"submit\" value=\"送信\">\n";
						print "</p>\n</form>\n";
					}
				}
				print "<hr>\n";
				print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin&action=kirilist\">戻る</a></p>\n";
				print "</body>\n</html>";
			} elsif($FORM{'action'} eq "kirisend") {
				#キリ番ログの編集の送信
				print "Content-type: text/html\n\n";
				print "<html lang=\"ja-jp\">\n<head>\n";
				print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
				print "<title>SQLカウンタ　管理画面</title>\n";
				print "</head>\n<body>\n";
				print "<h2>SQLカウンタ　管理画面</h2>\n";
				print "<h3>キリ番ログ編集</h3>\n";
				if($FORM{'id'} !~ /^[0-9]+$/) {
					print "<p>エラー：IDが不正です。</p>\n";
				} else {
					if(length($FORM{'name'})>$comment_max || length($FORM{'comment'})>$comment_max) {
						print "<p>エラー：コメントが長すぎます。</p>\n";
					} else {
						#名前のHTMLエスケープ
						$FORM{'name'} =~ s/&/&amp;/g;
						$FORM{'name'} =~ s/ /&nbsp;/g;
						$FORM{'name'} =~ s/"/&quot;/g;
						$FORM{'name'} =~ s/</&lt;/g;
						$FORM{'name'} =~ s/>/&gt;/g;
						$FORM{'name'} =~ s/\r\n/\n/g;
						$FORM{'name'} =~ s/\r/\n/g;
						$FORM{'name'} =~ s/\n//g;
						#コメントのHTMLエスケープ
						$FORM{'comment'} =~ s/&/&amp;/g;
						$FORM{'comment'} =~ s/ /&nbsp;/g;
						$FORM{'comment'} =~ s/"/&quot;/g;
						$FORM{'comment'} =~ s/</&lt;/g;
						$FORM{'comment'} =~ s/>/&gt;/g;
						$FORM{'comment'} =~ s/\r\n/\n/g;
						$FORM{'comment'} =~ s/\r/\n/g;
						$FORM{'comment'} =~ s/\n/<br>\n/g;
						#削除
						if($FORM{'status'} eq "delete") {
							$sql="delete from sqlcount_kirilog where id=".$FORM{'id'}.";";
							$dbh->do($sql);
							print "<p>削除を行いました。</p>\n";
						} else {
							$reported="";
							if($FORM{'status'} eq "notreported") {
								$reported=",reported=0";
							} elsif($FORM{'status'} eq "reported") {
								$reported=",reported=1";
							}
							$sql="update sqlcount_kirilog set name=".$dbh->quote($FORM{'name'}).
								",comment=".$dbh->quote($FORM{'comment'}).$reported.
								" where id=".$FORM{'id'}.";";
							$dbh->do($sql);
							print "<p>編集を行いました。</p>\n";
						}
					}
				}
				print "<hr>\n";
				print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin&action=kirilist\">戻る</a></p>\n";
				print "</body>\n</html>"
			} elsif($FORM{'action'} eq "logout") {
				$sql="delete from sqlcount_adminlogin where id=".$dbh->quote($COOKIE{'id'}).
					" and ipaddr=".$dbh->quote($ENV{'REMOTE_ADDR'}).";";
				$dbh->do($sql);
				print &clearCookie("id");
				print "Content-type: text/html\n\n";
				print "<html lang=\"ja-jp\">\n<head>\n";
				print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
				print "<title>SQLカウンタ　管理画面</title>\n";
				print "</head>\n<body>\n";
				print "<h2>SQLカウンタ　管理画面</h2>\n";
				print "<p>ログアウトしました。</p>\n";
				print "<hr>\n";
				if($CONFIG{'do_kirilog'}) {
					print "<p><a href=\"$ENV{'SCRIPT_NAME'}\">戻る</a></p>\n";
				} else {
					print "<p><a href=\"$return_url\">戻る</a></p>\n";
				}
				print "</body>\n</html>";
			} else {
				print "Content-type: text/html\n\n";
				print "<html lang=\"ja-jp\">\n<head>\n";
				print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
				print "<title>SQLカウンタ　管理画面</title>\n";
				print "</head>\n<body>\n";
				print "<h2>SQLカウンタ　管理画面</h2>\n";
				print "<h3>カウンタ値の変更</h3>\n";
				print "<form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
				print "<table border=\"3\">\n";
				print "<tr><th>種類</th><th>値</th></tr>\n";
				print "<tr><td>合計</td>\n";
				print "<td><input type=\"text\" name=\"total\" value=\"$COUNT{'total'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>今日</td>\n";
				print "<td><input type=\"text\" name=\"today\" value=\"$COUNT{'today'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>昨日</td>\n";
				print "<td><input type=\"text\" name=\"yesterday\" value=\"$COUNT{'yesterday'}\" size=\"10\"></td></tr>\n";
				print "</table>\n";
				print "<p>\n";
				print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
				print "<input type=\"hidden\" name=\"action\" value=\"setcount\">\n";
				print "<input type=\"submit\" value=\"送信\">\n";
				print "</p>\n</form>\n";
				print "<hr>\n";
				print "<h3>設定の変更</h3>\n";
				print "<ul>\n";
				print "<li>桁数は1以上にしてください。\n";
				print "<li>二重カウントしない時間を0以下など短い時間に設定すると、<br>";
				print "日別カウンタへのアクセスが別にカウントされます。\n";
				print "<li>キリ番の各条件は0にすると無効になります。\n";
				print "<li>ゾロ目の条件は負の値の時、-n桁以上の全ての桁がゾロ目になります。\n";
				print "</ul>\n";
				print "<form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
				print "<table border=\"3\">\n";
				print "<caption>一般的な設定</caption>\n";
				print "<tr><th>種類</th><th>値</th></tr>\n";
				print "<tr><td>カウンタの桁数</td>\n";
				print "<td><input type=\"text\" name=\"keta\" value=\"$CONFIG{'keta'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>日別カウンタの桁数</td>\n";
				print "<td><input type=\"text\" name=\"dayketa\" value=\"$CONFIG{'dayketa'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>桁数オーバーのときどうするか</td>\n";
				print "<td><select name=\"overmode\">\n";
				print "<option value=\"0\"".($CONFIG{'overmode'}==0?" selected":"").">下の方の桁のみ表\示\n";
				print "<option value=\"1\"".($CONFIG{'overmode'}==1?" selected":"").">すべての数字に9を表\示\n";
				print "<option value=\"2\"".($CONFIG{'overmode'}==2?" selected":"").">エラーを表\示\n";
				print "<option value=\"3\"".($CONFIG{'overmode'}==3?" selected":"").">必要な桁数を強制的に表\示\n";
				print "</select></td></tr>\n";
				print "<tr><td>二重カウントしない時間(秒)</td>\n";
				print "<td><input type=\"text\" name=\"nodtime\" value=\"$CONFIG{'nodtime'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>キリ番の表\示</td>\n";
				print "<td><input type=\"checkbox\" name=\"show_kiri\" id=\"show_kiri\"".($CONFIG{'show_kiri'}?" checked":"").">\n";
				print "<label for=\"show_kiri\">する</label></td></tr>\n";
				print "<tr><td>キリ番のログ取得</td>\n";
				print "<td><input type=\"checkbox\" name=\"do_sqlcount_kirilog\" id=\"do_sqlcount_kirilog\"".($CONFIG{'do_kirilog'}?" checked":"").">\n";
				print "<label for=\"do_sqlcount_kirilog\">する</label></td></tr>\n";
				print "</table>\n";
				print "<table border=\"3\">\n";
				print "<caption>キリ番の条件の設定</caption>\n";
				print "<tr><th>種類</th><th>値</th></tr>\n";
				print "<tr><td>10^nの倍数</td>\n";
				print "<td><input type=\"text\" name=\"kiri_10bai\" value=\"$CONFIG{'kiri_10bai'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>ミラー番の最低桁数</td>\n";
				print "<td><input type=\"text\" name=\"kiri_mirror\" value=\"$CONFIG{'kiri_mirror'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>左からの連番の最低桁数</td>\n";
				print "<td><input type=\"text\" name=\"kiri_leftlen\" value=\"$CONFIG{'kiri_leftlen'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>右からの連番の最低桁数</td>\n";
				print "<td><input type=\"text\" name=\"kiri_rightlen\" value=\"$CONFIG{'kiri_rightlen'}\" size=\"10\"></td></tr>\n";
				print "<tr><td>下n桁がゾロ目</td>\n";
				print "<td><input type=\"text\" name=\"kiri_zorome\" value=\"$CONFIG{'kiri_zorome'}\" size=\"10\"></td></tr>\n";
				print "</table>\n";
				print "<p>\n";
				print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
				print "<input type=\"hidden\" name=\"action\" value=\"setconfig\">\n";
				print "<input type=\"submit\" value=\"送信\">\n";
				print "</p>\n</form>\n";
				print "<hr>\n";
				print "<h3>キリ番ログの編集</h3>\n";
				print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin&action=kirilist\">一覧画面へ</a></p>\n";
				print "<hr>\n";
				print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin&action=logout\">ログアウト</a></p>\n";
				print "</body>\n</html>";
			}
		}
	}
} elsif($FORM{'mode'} eq "kirisend") {
	#キリ番の報告
	if($FORM{'gotban'} !~ /^[0-9]+$/) {
		print "Content-type: text/html\n\n";
		print "<html lang=\"ja-jp\">\n<head>\n";
		print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
		print "<title>SQLカウンタ　キリ番報告</title>\n";
		print "</head>\n<body>\n";
		print "<h2>SQLカウンタ　キリ番報告</h2>\n";
		print "<p>エラー：取ったキリ番が不正です。</p>\n";
		print "<hr>\n";
		print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=kiriform\">戻る</a></p>\n";
		print "</body>\n</html>";
	} else {
		if(length($FORM{'name'})>$comment_max || length($FORM{'comment'})>$comment_max) {
			print "Content-type: text/html\n\n";
			print "<html lang=\"ja-jp\">\n<head>\n";
			print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
			print "<title>SQLカウンタ　キリ番報告</title>\n";
			print "</head>\n<body>\n";
			print "<h2>SQLカウンタ　キリ番報告</h2>\n";
			print "<p>エラー：コメントが長すぎます。</p>\n";
			print "<hr>\n";
			print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=kiriform\">戻る</a></p>\n";
			print "</body>\n</html>";
		} else {
			#名前のHTMLエスケープ
			$FORM{'name'} =~ s/&/&amp;/g;
			$FORM{'name'} =~ s/ /&nbsp;/g;
			$FORM{'name'} =~ s/"/&quot;/g;
			$FORM{'name'} =~ s/</&lt;/g;
			$FORM{'name'} =~ s/>/&gt;/g;
			$FORM{'name'} =~ s/\r\n/\n/g;
			$FORM{'name'} =~ s/\r/\n/g;
			$FORM{'name'} =~ s/\n//g;
			#コメントのHTMLエスケープ
			$FORM{'comment'} =~ s/&/&amp;/g;
			$FORM{'comment'} =~ s/ /&nbsp;/g;
			$FORM{'comment'} =~ s/"/&quot;/g;
			$FORM{'comment'} =~ s/</&lt;/g;
			$FORM{'comment'} =~ s/>/&gt;/g;
			$FORM{'comment'} =~ s/\r\n/\n/g;
			$FORM{'comment'} =~ s/\r/\n/g;
			$FORM{'comment'} =~ s/\n/<br>\n/g;
			#そのキリ番があるかを探す
			$found=0;
			$sql="select id from sqlcount_kirilog where ipaddr=".$dbh->quote($ENV{'REMOTE_ADDR'}).
				" and count=".$FORM{'gotban'}." and reported=0 order by zikan desc limit 1;";
			if($sth = $dbh->prepare($sql)) {
				if($rv = $sth->execute) {
					if(@row = $sth->fetchrow_array) {
						$found=1;
						$id=$row[0];
					}
					$sth->finish;
				}
			}
			if($found) {
				$sql="update sqlcount_kirilog set reported=1,name=".$dbh->quote($FORM{'name'}).
					",comment=".$dbh->quote($FORM{'comment'})." where id=".$id.";";
				$dbh->do($sql);
				print "Content-type: text/html\n\n";
				print "<html lang=\"ja-jp\">\n<head>\n";
				print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
				print "<title>SQLカウンタ　キリ番報告</title>\n";
				print "</head>\n<body>\n";
				print "<h2>SQLカウンタ　キリ番報告</h2>\n";
				print "<p>報告を受け付けました。</p>\n";
				print "<hr>\n";
				print "<p><a href=\"$return_url\">戻る</a></p>\n";
				print "</body>\n</html>";
			} else {
				print "Content-type: text/html\n\n";
				print "<html lang=\"ja-jp\">\n<head>\n";
				print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
				print "<title>SQLカウンタ　キリ番報告</title>\n";
				print "</head>\n<body>\n";
				print "<h2>SQLカウンタ　キリ番報告</h2>\n";
				print "<p>エラー：報告されたキリ番はありません。<br>\n";
				print "本人以外からの報告はできません。</p>\n";
				print "<hr>\n";
				print "<p><a href=\"$ENV{'SCRIPT_NAME'}?mode=kiriform\">戻る</a></p>\n";
				print "</body>\n</html>";
			}
		}
	}
} elsif($FORM{'mode'} eq "kiriform") {
	#キリ番の報告フォーム
	$kiriban="";
	$sql="select count from sqlcount_kirilog where ipaddr=".$dbh->quote($ENV{'REMOTE_ADDR'}).
		" and reported=0 order by zikan desc limit 1;";
	if($sth = $dbh->prepare($sql)) {
		if($rv = $sth->execute) {
			if(@row = $sth->fetchrow_array) {
				$kiriban="".$row[0];
			}
			$sth->finish;
		}
	}
	print "Content-type: text/html\n\n";
	print "<html lang=\"ja-jp\">\n<head>\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
	print "<title>SQLカウンタ　キリ番報告</title>\n";
	print "</head>\n<body>\n";
	print "<h2>SQLカウンタ　キリ番報告</h2>\n";
	print "<p>コメントは$comment_maxバイトまでです。</p>\n";
	print "<form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
	print "<table border=\"3\">\n";
	print "<tr><td>取ったキリ番(必須)</td>\n";
	print "<td><input type=\"text\" name=\"gotban\" value=\"$kiriban\" size=\"30\"></td></tr>\n";
	print "<tr><td>名前(任意)</td>\n";
	print "<td><input type=\"text\" name=\"name\" value=\"\" size=\"30\"></td></tr>\n";
	print "<tr><td>コメント</td>\n";
	print "<td><textarea name=\"comment\" rows=\"5\" cols=\"50\"></textarea></td></tr>\n";
	print "</table>\n";
	print "<p>\n";
	print "<input type=\"hidden\" name=\"mode\" value=\"kirisend\">\n";
	print "<input type=\"submit\" value=\"送信\">\n";
	print "</p>\n<hr>\n";
	print "<p><a href=\"$return_url\">戻る</a></p>\n";
	print "</body>\n</html>";
} else {
	#キリ番ログの表示
	if($CONFIG{'do_kirilog'}) {
		print "Content-type: text/html\n\n";
		print "<html lang=\"ja-jp\">\n<head>\n";
		print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
		print "<title>SQLカウンタ　キリ番一覧</title>\n";
		print "</head>\n<body>\n";
		print "<h2>SQLカウンタ　キリ番一覧</h2>\n";
		print "<h3>キリ番の条件</h3>\n";
		print "<ul>\n";
		if($CONFIG{'kiri_10bai'}>0) {
			$target=1;
			for($i=0;$i<$CONFIG{'kiri_10bai'};$i++){$target*=10;}
			print "<li>$targetの倍数\n";
		}
		if($CONFIG{'kiri_mirror'}>0) {
			print "<li>$CONFIG{'kiri_mirror'}桁以上のミラー番\n";
		}
		if($CONFIG{'kiri_leftlen'}>0) {
			print "<li>$CONFIG{'kiri_leftlen'}桁以上の左からの連番\n";
		}
		if($CONFIG{'kiri_rightlen'}>0) {
			print "<li>$CONFIG{'kiri_rightlen'}桁以上の右からの連番\n";
		}
		if($CONFIG{'kiri_zorome'}>0) {
			print "<li>下$CONFIG{'kiri_zorome'}桁以上がゾロ目\n";
		} elsif($CONFIG{'kiri_zorome'}<0) {
			print "<li>".(-$CONFIG{'kiri_zorome'})."桁以上のゾロ目\n";
		}
		print "</ul>\n";
		print "<h3>キリ番一覧</h3>\n";
		print "<table border=\"3\">\n";
		print "<tr><th>キリ番</th><th>取得された時刻</th>\n";
		print "<th>取得した人の名前</th><th>取得した人のコメント</th></tr>\n";
		#キリ番一覧を読みだし
		@wdays = ( "日", "月", "火", "水", "木", "金", "土", "日" );
		$sql="select reported,count,zikan,name,comment from sqlcount_kirilog order by zikan desc;";
		if($sth = $dbh->prepare($sql)) {
			if($rv = $sth->execute) {
				while(@row = $sth->fetchrow_array) {
					($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($row[2]);
					$zikoku=sprintf("%d年%d月%d日(%s)　%d時%d分%d秒",
						$year+1900,$mon+1,$mday,$wdays[$wday],$hour,$min,$sec);
					if($row[0]) {
						#報告済み
						print "<tr><td>$row[1]</td><td>$zikoku</td>";
						print "<td>$row[3]</td><td>$row[4]</td></tr>\n";
					} else {
						#未報告
						print "<tr><td>$row[1]</td><td>$zikoku</td>";
						print "<td>(未報告)</td><td>(未報告)</td></tr>\n";
					}
				}
				$sth->finish;
			}
		}
		#続きを書き出し
		print "</table>\n";
		print "<hr>\n";
		print "<p><a href=\"$return_url\">戻る</a></p>\n";
		print "<p align=\"right\"><a href=\"$ENV{'SCRIPT_NAME'}?mode=admin\">管理</a></p>\n";
		print "</body>\n</html>";
	} else {
		#キリ番ログが無効なら管理画面に飛ばす
		print "Location: $ENV{'SCRIPT_NAME'}?mode=admin\n\n";
	}
}

#データベースから切断
if(defined($dbh)){$dbh->disconnect();}

#今日の日付を整数で取得
sub gettoday {
	local($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime(time);
	$year+=1900;
	$mon++;
	return $year*10000+$mon*100+$mday;
}
#昨日の日付を整数で取得

sub getyesterday {
	local(@daylist)=(31,28,31,30,31,30,31,31,30,31,30,31);
	#今日の日付を取得
	local($today_date)=(@_);
	$year=int($today_date/10000);
	$mon=int($today_date/100)%100;
	$mday=$today_date%100;
	#昨日にする
	$mday--;
	if($mday<=0) {
		if($mon<=1) {
			$year--;
			$mon=12;
			$mday=$daylist[11];
		} else {
			$mon--;
			$mday=$daylist[$mon-1];
			if($mon==2) {
				#閏年の判定
				if($year%400==0 || ($year%4==0 && $year%100!=0)) {
					$mday=29;
				}
			}
		}
	}
	return $year*10000+$mon*100+$mday;
}

#http://www.tohoho-web.com/cgi/wwwcook.txtより一部改変

#
# Cookieの値を読み出す
#
sub getCookie {
	local($xx, $name, $value);
	foreach $xx (split(/; */, $ENV{'HTTP_COOKIE'})) {
		($name, $value) = split(/=/, $xx);
		$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
		$COOKIE{$name} = $value;
	}
}

#
# Cookieに値を書き込むためのSet-Cookie:ヘッダを生成する
#
sub setCookie {
	local(@wdays) = ( "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun" );
	local(@months) = ( "Jan", "Feb", "Mar", "Apr", "May", "Jun",
	                   "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );
	local($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime(time);
	local($tmp, $val,$date);
	#内容を設定
	$val = $_[1];
	$val =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
	$tmp = "Set-Cookie: ";
	$tmp .= "$_[0]=$val;";
	#時間を設定
	$date=sprintf("%s, %d-%s-%d %02d:0%02d:%02d",
		$wdays[$wday],$mon+1,$months[$mon],$hour,$min,$sec);
	$tmp .= " expires=$date GMT;\n";
	return($tmp);
}

#
# Cookieを削除するためのSet-Cookie:ヘッダを生成する
#
sub clearCookie {
	local($tmp);
	$tmp = "Set-Cookie: ";
	$tmp .= "$_[0]=xx; ";
	$tmp .= " expires=Tue, 1-Jan-1980 00:00:00 GMT;\n";
	return($tmp);
}